dim zoom(10)            rem An array of our zoom values
data 1,2,3,5,8,14,24    rem Default zoom values
                        rem The following is the patch table
data 0
Version1:
data 98687,6,98694,7,98702,5,98709,6,98717,4,98724,5,98732,3,98739,4
data 98747,2,98754,3,98762,2,98797,2,98804,1,98812,3,98819,2,98827,4
data 98834,3,98842,5,98849,4,98857,6,98864,5,98872,6
data 98948,1,98961,2,98974,3,98987,4,99000,5,99013,6,99026,7
data 262145,0
Version2:

for j=1 to 7:zoom(j)=101:next j

incmd$=command$         rem Get the command line

if incmd$<>"" then
  cls
  print
  print "----------------------------------------------------------"
  print "Cmdline: AutXZoom [zoom1] [zoom2]...[zoom7]               "
  print "  This utility patches the traxedit.exe binary so that the"
  print "  PgUP/PgDOWN zoom function gives better, finer, steps in "
  print "  zoom - more suitable for good PCB design, esp. SMD work."
  print "  The patch only works on the 168,848 byte 16/7/1992 V1.61"
  print "  binary file 'traxedit.exe' normally found in C:\autotrax"
  print "Run the program in the autotrax directory with no command "
  print "  line arguments for default zooms, or run with a list of "
  print "  zooms on the command line if you want your own values.  "
  print "  Zooms are 7 integers in range 1-100, eg: 1,2,3,5,8,14,24"
  print "Updates at: http://www.airborn.com.au/layout/easytrax.html"
  print "                                                 30/8/2003"
  print "Cmdline: AutXZoom [zoom1] [zoom2]...[zoom7]               "
  print "----------------------------------------------------------"
else
  print "----------------------------------------------------------"
  print "AutXZoom patches Autotrax (traxedit.exe) for better zoom.."
  print "  (Run with ? switch: 'AutXZoom.exe ?' for full details)  "
end if

ProcessNextParameter:
  if incmd$="" then goto FillInRest
                        rem Get a zoom value from the command line
  zoom$ = Extract$ (incmd$, ANY " ,;/+") :Print "Selecting zoom: "; zoom$
  zoom(0)= int (abs (val (zoom$) ) )

                        rem Scope check it; - legal vals are 1-100
  if zoom(0) = 0 then print "Remember to use only zoom values 1-100":end
  if zoom(0) > 100 then zoom(0) = 100

                        rem Sort the list
  gosub SortZoom
  Watchdog = Watchdog + 1:If Watchdog > 10 then end

                        rem Strip the parameter off the command line
  incmd$ = ltrim$( mid$(incmd$, (len (zoom$) + 1 ) ), ANY " ,;/+")
  Goto ProcessNextParameter

FillInRest:             rem Fill in values to make a total of seven
  if zoom(7) < 101 then DoneFillIn
  read zoom(0)
  gosub SortZoom
  Watchdog = Watchdog + 1:If Watchdog < 20 then FillInRest

DoneFillIn:
  print "Original autotrax zoom values: 1x 3x 5x 10x 20x 50x 100x"
  Print "The 7 new Zoom values will be:";
  for j=1 to 7:print zoom(j);:next j:print

EmptyData:
  Read j:If j<>0 then goto Emptydata

if dir$("traxedit.old") <> "" then HaveTemplate
if dir$("traxedit.exe") <> "" then HaveMaster
chdir "\"
if dir$("autotrax",16) = "" then Print "Please run in autotrax directory":end
chdir "autotrax"
if incmd$<>"" then Print "Changing to directory: "; curdir$
if dir$("traxedit.old") <> "" then HaveTemplate
if dir$("traxedit.exe") = "" then Print "Could not find traxedit.exe":end

HaveMaster:
Name "TRAXEDIT.EXE" as "Traxedit.old"
HaveTemplate:
if dir$("traxedit.exe") <> "" then kill "traxedit.exe"

open "Traxedit.old" for binary as #1
open "Traxedit.exe" for output as #2
print "Updating file"
read trigger:read newval
position=0:bad=0

Get1:
if eof(1) then
  close:if position <> 168848 then bad=1
  if bad = 0 then
    print
    print "File update complete: Traxedit.exe has the new zoom values"
    print "----------------------------------------------------------"
    end
  else
    kill "Traxedit.exe"
    Name "Traxedit.old" as "Traxedit.exe"
    Print "Update Unsuccessful, (error above), restored original file"
    print "----------------------------------------------------------"
    end
  end if
end if

  if not eof(1) then
    get$ #1,1,a$
    if not eof(1) then
      d1%=asc(a$)
      if position = 0 then if d1% <> 77 then print "Not Exe File":bad=1
      if position = 1 then if d1% <> 90 then Print "Not Exe File(2)":bad=1
      if position = 2 then
        print "             0%     20%     40%     60%     80%     100%  "
        print "Please wait: ";
      end if
      if position = 10793 then if d1% <> 49 then print "Version err":bad=1
      if position = 10794 then if d1% <> 46 then bad=1
      if position = 10795 then if d1% <> 54 then bad=1
      if position = 10796 then if d1% <> 49 then bad=1

      if bad=0 then
        if position=trigger then d1%=zoom(newval):read trigger:read newval
        if int((position+1)/4096) = (position+1)/4096 then print "-";
      end if
      print #2,chr$(d1%);
      position = position + 1:If position > 262143 then close
    end if
  end if

Goto Get1

SortZoom:
  for j=1 to 7
    if zoom(j) = zoom(0) then DoneSortZoom
    if zoom(0) < zoom(j) then swap zoom(0), zoom(j)
  next j
DoneSortZoom:
  return



